<template>
  <div :class="`container ${type ? 'sign-up-mode' : ''}`">
    <div class="forms-container">
      <div class="signin-signup">
        <el-form :model='loginForm' :rules="rules" ref="submitForm" class="sign-in-form">
          <div class="title-note">
            Welcome 欢迎登录
          </div>
          <el-form-item prop="userName">
            <div class="input-field">
              <svg-icon icon-class="userLogin"></svg-icon>
              <el-input clearable v-model='loginForm.userName' type="text" placeholder="用户名" />
            </div>
          </el-form-item>
          <el-form-item prop="password">
            <div class="input-field">
              <svg-icon icon-class="pswLogin"></svg-icon>
              <el-input clearable v-model='loginForm.password' :type="passw" placeholder="密码">
                <i slot="suffix" :class="icon" @click="showPass(passw)"></i>
              </el-input>
            </div>
          </el-form-item>
          <el-form-item prop="identifyCode">
            <div class="input-field">
              <svg-icon icon-class="guide"></svg-icon>
              <el-input v-model='loginForm.identifyCode' placeholder="验证码" @keyup.enter.native="submit('submitForm')">
              </el-input>
              <div class="identi_img">
                <img :src="src" @click="getCode()" />
              </div>
            </div>
          </el-form-item>
          <el-button :loading="loading" @click="submit('submitForm')" class="btn solid">登 录</el-button>
        </el-form>
        <el-form :model="registerForm" :rules="rules" ref="registerForm" class="sign-up-form">
          <div class="title-note">
            Welcome 欢迎注册
          </div>
          <el-form-item prop="username">
            <div class="input-field">
              <svg-icon icon-class="userLogin"></svg-icon>
              <el-input type="text" v-model="registerForm.username" placeholder="用户名" />
            </div>
          </el-form-item>
          <el-form-item prop="password">
            <div class="input-field">
              <svg-icon icon-class="pswLogin"></svg-icon>
              <el-input v-model='registerForm.password' :type="passw" placeholder="密码">
                <i slot="suffix" :class="icon" @click="showPass(passw)"></i>
              </el-input>
            </div>
          </el-form-item>
          <el-button :loading="loading" @click="submit('registerForm')" class="btn solid">注 册</el-button>
        </el-form>
      </div>
    </div>
    <div class="panels-container">
      <div class="panel left-panel">
        <div class="content">
          <h1 style="letter-spacing: 10px">典策综合档案管理系统</h1>
          <!-- <div style="letter-spacing: 8px;font-size:35px;font-weight:600">综合档案管理系统</div> -->
          <p>Welcome 欢迎注册</p>
          <button class="btn transparent" id="sign-up-btn" @click="Sign">
            注册
          </button>
        </div>
        <img src="@/assets/img/log.svg" class="image" alt="" />
      </div>
      <div class="panel right-panel">
        <div class="content">
          <h1 style="letter-spacing: 10px">典策综合档案管理系统</h1>
          <p>Welcome 欢迎登录</p>
          <button class="btn transparent" id="sign-in-btn" @click="Sign">
            登录
          </button>
        </div>
        <img src="@/assets/img/register.svg" class="image" alt="" />

      </div>
    </div>
    <registrationdialog :jurisdiction="jurisdiction" :machineRules="machineRules" :ruleForm="ruleForm"
      @cancel="cancel" />
  </div>
</template>
<script>
  import registrationdialog from "./registrationdialog.vue"
  import {
    getDbMac2,
    getLocalMac,
    saveDbMac
  } from "@/api/user";
  import {
    clearObjValue,
    message
  } from "@/utils/common"
  import {
    checkCode,
    checkCodeImage,
    login,
    registerUser
  } from "@/api/login"
  import localStronge from "@/api/localData";
  import {
    validUsername
  } from "@/utils/validate";
  import Layout from '@/layout'
  import websocket from "../../mixins/websocket"
  import {
    constantRoutes
  } from '@/router'
  export default {
    mixins: [websocket],
    name: "Login",
    components: {
      registrationdialog
    },
    data() {
      var validatePass = (rule, value, callback) => {
        if (value === "") {
          return callback(new Error("请输入密码！"));
        } else {
          callback();
        }
      };
      var checkName = (rule, value, callback) => {
        if (!value) {
          return callback(new Error("用户名不能为空！"));
        } else {
          callback();
        }
      };
      var checkCode = (rule, value, callback) => {
        if (!value) {
          return callback(new Error("验证码不能为空！"));
        } else {
          callback();
        }
      };
      return {
        ruleForm: {
          machineCode: "",
          password: "",
          roleId: "",
        },
        machineRules: {
          machineCode: [{
            required: true,
            message: "请输入机器码",
            trigger: "blur"
          }, ],
          password: [{
            required: true,
            message: "请输入注册码",
            trigger: "blur"
          }, ],
        },
        jurisdiction: false,
        passw: "password",
        icon: "el-input__icon el-icon-view",
        type: 0,
        loginForm: {
          userName: "",
          password: "",
          identifyCode: "",
        },
        registerForm: {
          username: "",
          password: "",
        },
        loading: false,
        rules: {
          password: [{
            validator: validatePass,
            trigger: "blur"
          }],
          userName: [{
            validator: checkName,
            trigger: "blur"
          }],
          identifyCode: [{
            validator: checkCode,
            trigger: "blur"
          }],
        },
        identiCode: "",
        src: "",
      };
    },
    watch: {
      $route: {
        handler: function (route) {
          this.redirect = route.query && route.query.redirect;
        },
        immediate: true,
      },
    },
    methods: {
      async getMac2() {
        await getDbMac2().then(res => {
          this.jurisdiction = false;
        }).catch(err => {
          this.jurisdiction = true;
        })
      },
      getLocalMac() {
        getLocalMac().then((res) => {
          this.ruleForm.machineCode = res;
        });
      },
      cancel() {
        this.jurisdiction = false;
      },
      showPass(val) {
        if (val == "text") {
          this.passw = "password";
          //更换图标
          this.icon = "el-input__icon el-icon-view";
        } else {
          this.passw = "text";
          this.icon = "el-input__icon el-icon-loading";
        };
      },
      Sign() {
        this.showPass('text')
        if (this.type) {
          clearObjValue(this.loginForm)
          this.$refs['submitForm'].clearValidate();
          this.type = 0;
        } else {
          this.$refs['registerForm'].clearValidate();
          clearObjValue(this.registerForm)
          this.type = 1;

        }
      },
      showPwd() {
        if (this.passwordType === "password") {
          this.passwordType = "";
        } else {
          this.passwordType = "password";
        }
        this.$nextTick(() => {
          this.$refs.password.focus();
        });
      },
      submit(formName) {
        if (formName === 'submitForm') {
          this.$refs["submitForm"].validate((valid) => {
            if (valid) {
              this.loading = true;
              let param = {
                username: this.loginForm.userName,
                password: this.loginForm.password,
              };
              login(param).then(res => {
                if (res.success) {
                  // if (
                  //   this.loginForm.identifyCode.toUpperCase() !==
                  //   this.identiCode.toUpperCase()
                  // ) {
                  //   this.$message.error("验证码错误，请重新输入！");
                  //   this.getIdentifyCode();
                  // } else {
                  let menu = res.body.userRole.roles[0].menus;
                  this.sumbitFuncTypeCode(menu);
                  localStronge.setMenus(menu);
                  sessionStorage.setItem("username", this.loginForm.userName);
                  sessionStorage.setItem("userid", res.body.userRole.user.id);
                  sessionStorage.setItem("roleid", res.body.userRole.roles[0].roleCode);
                  sessionStorage.setItem('passWorld', res.body.userRole.user.password)
                  sessionStorage.setItem(
                    "roles",
                    res.body.userRole.roles[0].roleName
                  );
                  localStronge.setToken(res.body.token);
                  this.$router.push({
                    path: "/"
                  });
                  if (!this.socket) {
                    this.init()
                  }
                }
                this.loading = false;
                // }

              }).catch(err => {
                this.loading = false;
              })


            } else {

              return false;
            }
          });
        } else {
          this.$refs[formName].validate((valid) => {
            if (valid) {
              this.loading = true;
              let param = {
                username: this.registerForm.username,
                password: this.registerForm.password,
                markEnable: 1
              };
              registerUser(param).then(res => {
                message("success", "注册成功", 3000)
                this.loading = false
              }).catch(err => {
                this.loading = false
              })
            } else {
              return false;
            }
          });
        }
      },
      handleLogin() {
        this.$refs.loginForm.validate((valid) => {
          if (valid) {
            this.loading = true;
            this.$store
              .dispatch("user/login", this.loginForm)
              .then(() => {
                this.$router.push({
                  path: this.redirect || "/"
                });
                this.loading = false;
              })
              .catch(() => {
                this.loading = false;
              });
          } else {
            console.log("error submit!!");
            return false;
          }
        });
      },
      getCode() {
        this.getIdentifyCode();
      },
      getIdentifyCode() {
        checkCode().then(res => {
          this.identiCode = res.body.checkCode_session;
          let param = {
            returnCheckCode: this.identiCode
          };
          checkCodeImage(param).then(res => {
            this.src = "data:image/jpg;base64," + res.body.img;
          })
        })
      },
      //拿到每个路由的
      sumbitFuncTypeCode(data) {
        let dashboard = [{
          path: '/',
          component: Layout,
          redirect: '/dashboard',
          children: [{
            path: '/dashboard',
            name: 'Dashboard',
            component: () => import('@/views/dashboard/index'),
            meta: {
              title: '首页',
              icon: 'dashboard',
              affix: true
            }
          }]
        }]
        let TypeList = {}
        let idList = {}
        let list = []
        let OtherRouter = []
        constantRoutes.forEach(item => {
          if (item.path === "/login" || item.path === "/404" || item.path === "/" || item.path === "*") {
            OtherRouter.push(item)
          }
        })
        data.forEach(ele => {
          let obj = {}
          obj.children = []

          // if (ele.childs && !ele.childs.length) {
          if (!ele.childs || !ele.childs.length) {
            idList[ele.url] = ele.id
            let menus = {}
            menus.path = ele.url
            menus.meta = {
              title: ele.name,
              noCache: true,
              icon: ele.icon
            }
            obj.children.push(menus)
            if (ele.url && ele.funcTypeCode) {
              TypeList[ele.url] = ele.funcTypeCode
            }
          } else {
            obj.path = ele.url
            obj.component = Layout
            obj.alwaysShow = true
            obj.meta = {
              title: ele.name,
              icon: ele.icon,
              noCache: true
            }
            ele.childs.forEach(element => {
              idList[element.url] = element.id
              let menu = {}
              menu.path = element.url
              menu.children = []
              menu.meta = {
                title: element.name,
                noCache: true,
                icon: element.icon
              }
              if (element.childs != null && element.childs.length) {
                element.childs.forEach(aea => {
                  idList[aea.url] = aea.id
                  if (aea.childs === null) {
                    let me = {}
                    me.path = aea.url
                    me.meta = {
                      title: aea.name,
                      noCache: true,
                      icon: aea.icon
                    }
                    menu.children.push(me)
                    if (aea.url && aea.funcTypeCode) {
                      TypeList[aea.url] = aea.funcTypeCode
                    }
                  }
                })

              } else {
                if (element.url && element.funcTypeCode) {
                  TypeList[element.url] = element.funcTypeCode;
                }
              }
              obj.children.push(menu)
              // idList[element.url] = element.id
            })
          }
          list.push(obj)
        })
        this.routes = [...dashboard, ...list]
        sessionStorage.setItem('routes', JSON.stringify(this.routes))
        sessionStorage.setItem("funcTypeCodeList", JSON.stringify(TypeList));
        sessionStorage.setItem("routerIdList", JSON.stringify(idList));
        message("success", "登录成功", 3000);
        this.$router.push({
          path: "/dashboard"
        });
      },
    },
    created() {
      this.getIdentifyCode();
      this.getMac2();
      this.getLocalMac();
    }
  };

</script>
<style lang='scss' scoped>
  .container {
    position: relative;
    width: 100%;
    background-color: #fff;
    min-height: 100vh;
    overflow: hidden;
  }

  .forms-container {
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
  }

  .signin-signup {
    position: absolute;
    top: 50%;
    transform: translate(-50%, -50%);
    left: 75%;
    width: 50%;
    transition: 1s 0.7s ease-in-out;
    display: grid;
    grid-template-columns: 1fr;
    z-index: 5;
  }

  form {
    display: flex;
    align-items: center;
    justify-content: center;
    flex-direction: column;
    padding: 0rem 5rem;
    transition: all 0.2s 0.7s;
    overflow: hidden;
    grid-column: 1 / 2;
    grid-row: 1 / 2;
  }

  form.sign-up-form {
    opacity: 0;
    z-index: 1;
  }

  form.sign-in-form {
    z-index: 2;
  }

  .title {
    font-size: 2.2rem;
    color: #444;
    margin-bottom: 10px;
  }

  .input-field {
    max-width: 380px;
    width: 100%;
    background-color: #f0f0f0;
    margin: 12px 0;
    height: 55px;
    line-height: 55px;
    border-radius: 55px;
    display: grid;
    grid-template-columns: 15% 85%;
    padding: 0 0.4rem;
    position: relative;

    .identi_img {
      width: 25%;
      position: absolute;
      right: 8%;
      top: 20%;

      img {
        cursor: pointer;
      }
    }
  }

  .input-field i {
    text-align: center;
    line-height: 55px;
    color: #acacac;
    transition: 0.5s;
    font-size: 1.1rem;
  }

  .input-field svg {
    height: 55px;
    width: 45%;
    font-size: 1rem;
    margin-left: 35%;
    line-height: 55px;
    color: #acacac;
    transition: 0.5s;
  }

  .input-field input {
    background: none;
    outline: none;
    border: none;
    line-height: 1;
    font-weight: 600;
    font-size: 1.1rem;
    color: #333;
  }

  .input-field ::v-deep .el-input__inner {
    background: none;
    outline: none;
    border: none;
    line-height: 1;
    font-weight: 600;
    font-size: 1.1rem;
    color: #333;
  }

  .input-field ::v-deep .el-input__inner::placeholder {
    color: #aaa;
    font-weight: 600;
    letter-spacing: 2px;
  }

  .input-field input::placeholder {
    color: #aaa;
    font-weight: 600;
  }

  .social-text {
    padding: 0.7rem 0;
    font-size: 1rem;
  }

  .social-media {
    display: flex;
    justify-content: center;
  }

  .social-icon {
    height: 46px;
    width: 46px;
    display: flex;
    justify-content: center;
    align-items: center;
    margin: 0 0.45rem;
    color: #333;
    border-radius: 50%;
    border: 1px solid #333;
    text-decoration: none;
    font-size: 1.1rem;
    transition: 0.3s;
  }

  .social-icon:hover {
    color: #4481eb;
    border-color: #4481eb;
  }

  .btn {
    width: 150px;
    background-color: #5995fd;
    border: none;
    outline: none;
    height: 49px;
    border-radius: 49px;
    color: #fff;
    text-transform: uppercase;
    text-align: center;
    letter-spacing: 5px;
    font-size: 15px;
    font-weight: 600;
    margin: 10px 0;
    cursor: pointer;
    transition: 0.5s;
  }

  .btn:hover {
    background-color: #4d84e2;
  }

  .panels-container {
    position: absolute;
    height: 100%;
    width: 100%;
    top: 0;
    left: 0;
    display: grid;
    grid-template-columns: repeat(2, 1fr);
  }

  .container:before {
    content: "";
    position: absolute;
    height: 2000px;
    width: 2000px;
    top: -10%;
    right: 48%;
    transform: translateY(-50%);
    background-image: linear-gradient(-45deg, #4481eb 0%, #04befe 100%);
    transition: 1.8s ease-in-out;
    border-radius: 50%;
    z-index: 6;
  }

  .image {
    width: 100%;
    transition: transform 1.1s ease-in-out;
    transition-delay: 0.4s;
  }

  .panel {
    display: flex;
    flex-direction: column;
    align-items: flex-end;
    justify-content: space-around;
    text-align: center;
    z-index: 6;
  }

  .left-panel {
    pointer-events: all;
    padding: 3rem 17% 2rem 12%;
  }

  .right-panel {
    pointer-events: none;
    padding: 3rem 12% 2rem 17%;
  }

  .panel .content {
    color: #fff;
    transition: transform 0.9s ease-in-out;
    transition-delay: 0.6s;
  }

  .panel h3 {
    font-weight: 600;
    line-height: 1;
    font-size: 1.5rem;
  }

  .panel p {
    font-size: 0.95rem;
    padding: 0.7rem 0;
  }

  .btn.transparent {
    margin: 0;
    background: none;
    border: 2px solid #fff;
    width: 130px;
    height: 41px;
    font-weight: 600;
    font-size: 0.8rem;
  }

  .right-panel .image,
  .right-panel .content {
    transform: translateX(800px);
  }

  /* ANIMATION */

  .container.sign-up-mode:before {
    transform: translate(100%, -50%);
    right: 52%;
  }

  .container.sign-up-mode .left-panel .image,
  .container.sign-up-mode .left-panel .content {
    transform: translateX(-800px);
  }

  .container.sign-up-mode .signin-signup {
    left: 25%;
  }

  .container.sign-up-mode form.sign-up-form {
    opacity: 1;
    z-index: 2;
  }

  .container.sign-up-mode form.sign-in-form {
    opacity: 0;
    z-index: 1;
  }

  .container.sign-up-mode .right-panel .image,
  .container.sign-up-mode .right-panel .content {
    transform: translateX(0%);
  }

  .container.sign-up-mode .left-panel {
    pointer-events: none;
  }

  .container.sign-up-mode .right-panel {
    pointer-events: all;
  }

  @media (max-width: 870px) {
    .container {
      min-height: 800px;
      height: 100vh;
    }

    .signin-signup {
      width: 100%;
      top: 95%;
      transform: translate(-50%, -100%);
      transition: 1s 0.8s ease-in-out;
    }

    .signin-signup,
    .container.sign-up-mode .signin-signup {
      left: 50%;
    }

    .panels-container {
      grid-template-columns: 1fr;
      grid-template-rows: 1fr 2fr 1fr;
    }

    .panel {
      flex-direction: row;
      justify-content: space-around;
      align-items: center;
      padding: 2.5rem 8%;
      grid-column: 1 / 2;
    }

    .right-panel {
      grid-row: 3 / 4;
    }

    .left-panel {
      grid-row: 1 / 2;
    }

    .image {
      width: 200px;
      transition: transform 0.9s ease-in-out;
      transition-delay: 0.6s;
    }

    .panel .content {
      padding-right: 15%;
      transition: transform 0.9s ease-in-out;
      transition-delay: 0.8s;
    }

    .panel h3 {
      font-size: 1.2rem;
    }

    .panel p {
      font-size: 0.7rem;
      padding: 0.5rem 0;
    }

    .btn.transparent {
      width: 110px;
      height: 35px;
      font-size: 0.7rem;
    }

    .container:before {
      width: 1500px;
      height: 1500px;
      transform: translateX(-50%);
      left: 30%;
      bottom: 68%;
      right: initial;
      top: initial;
      transition: 2s ease-in-out;
    }

    .container.sign-up-mode:before {
      transform: translate(-50%, 100%);
      bottom: 32%;
      right: initial;
    }

    .container.sign-up-mode .left-panel .image,
    .container.sign-up-mode .left-panel .content {
      transform: translateY(-300px);
    }

    .container.sign-up-mode .right-panel .image,
    .container.sign-up-mode .right-panel .content {
      transform: translateY(0px);
    }

    .right-panel .image,
    .right-panel .content {
      transform: translateY(300px);
    }

    .container.sign-up-mode .signin-signup {
      top: 5%;
      transform: translate(-50%, 0);
    }
  }

  @media (max-width: 570px) {
    form {
      padding: 0 1.5rem;
    }

    .image {
      display: none;
    }

    .panel .content {
      padding: 0.5rem 1rem;
    }

    .container {
      padding: 1.5rem;
    }

    .container:before {
      bottom: 72%;
      left: 50%;
    }

    .container.sign-up-mode:before {
      bottom: 28%;
      left: 50%;
    }
  }

  .title-note {
    font-size: 20px;
    text-align: left;
    width: 55%;
    color: #868686;
    padding: 15px 0;
    font-weight: 600;
  }

  ::v-deep .el-form-item.is-error .el-form-item__error {
    color: #F56C6C;
    font-size: 12px;
    line-height: 1;
    padding-top: 0px;
    position: absolute;
    top: 95%;
    left: 8%;
  }

  .el-form-item--medium {
    margin-bottom: 5px;
  }

</style>
